/***********************************************************************\ 
*									* 
*   File: scorpion/src/idlview/idlview_master/idlview_master.h 
*				 					* 
*   Copyright (C) 1991 Vijay Anand
*									* 
*   The Scorpion System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you 	* 
*   retain credits referencing the University of Arizona and that you	* 
*   identify any changes you make.					* 
*									* 
*   Report problems to scorpion-project@cs.arizona.edu			* 
*   Direct all inquiries to:	The Scorpion Project			* 
*				Department of Computer Science		* 
*				Gould-Simpson Building			* 
*				University of Arizona			* 
*				Tucson, AZ 85721			* 
*				U.S.A.					* 
*									* 
*   Revision Log:							* 
*	$Log:$ 
*									* 
*   Edit Log:								* 
*     Jan 9 1991 (vijay) Created.					* 
*									* 
\***********************************************************************/ 

/*
 * Definitions for TCP and UDP client/server programs
 */
#include <rpc/rpc.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
/*#include <netinet/in.h>*/
#include <netdb.h>
#include <arpa/inet.h>
#include <sys/wait.h>

/*
#define TRUE                   1
#define FALSE                  0
*/

#define SERV_PORT           8050
#define BCAST_PORT          7001
/*#define MASTER_PORT         7050 */
#define MASTER_PORT         7070
#define SERV_HOST_NAME      "boojum.cs.arizona.edu"
#define MAXHSTNAMLNG        256
#define MAXSCKNAMLNG         10 
#define MAXPRTNUM            50
#define MAXWAIT             100
#define MAXSESLNG            20
#define MAXFILNAMLNG        256
#define MAXLEN              256

#define SUNWDW               's'
#define XWDW                 'x'
#define OPENWDW              'o'

typedef struct nettable {
  char *serv_host;
  char *disp_host;
  char *cdlfil;
  int port;
  int busy;
} *NETTABLE;

typedef struct startup {
  int flag;
  int fd;
  int port;
} STARTUP;

int  search_nettable();
void status_nettable();
int add_nettable();
void remove_nettable();
void addbackup(), deletebackup();
